#include <cstdlib>
#include <iostream>
#include "Dizionario.h"
#include "Studente.h"
using namespace std;

void presente (string matricola, circLista<Studente>& l1, circLista<Studente>& l2)
{
  Dizionario<string,Studente> d1(3);
  Dizionario<string,Studente> d2(3);
  circLista<Studente>::posizione indiceElemento = l1.primoLista();
  while (!l1.finelista(indiceElemento))
  {
        d1.inserisci(l1.leggilista(indiceElemento).getMatricola(),l1.leggilista(indiceElemento));
        indiceElemento=l1.succlista(indiceElemento);   
  }
  if (d1.appartiene(matricola))
  {
     cout << "Studente " << matricola << " presente\n";
     d1.recupera(matricola).stampa();     
  }   
  else
  {
      indiceElemento =  l2.primoLista();
      while (!l2.finelista(indiceElemento))
      {
        d2.inserisci(l2.leggilista(indiceElemento).getMatricola(),l2.leggilista(indiceElemento));
        indiceElemento=l2.succlista(indiceElemento);   
      }
      if (d2.appartiene(matricola))
      {
              cout << "Studente " << matricola << " presente\n";
         d2.recupera(matricola).stampa();     
      }
      else
           cout << "Studente " << matricola << " assente\n";
  }   
}

int contaAnnoiati (circLista<Studente>& l1, circLista<Studente>& l2)
{
     Dizionario<string,Studente> d(3);
     circLista<Studente>::posizione indiceElemento = l2.primoLista();
     while (!l2.finelista(indiceElemento))
      {
        d.inserisci(l2.leggilista(indiceElemento).getMatricola(),l2.leggilista(indiceElemento));
        indiceElemento=l2.succlista(indiceElemento);   
      }
      // ho riempito il dizionario
      int counter=0;
      indiceElemento = l1.primoLista();
      while (!l1.finelista(indiceElemento))
      {
        if (!d.appartiene(l1.leggilista(indiceElemento).getMatricola()))
           counter++;
        indiceElemento=l1.succlista(indiceElemento);   
      }
      return counter;
}


int main(int argc, char *argv[])
{
    circLista<Studente> lezione1;
    circLista<Studente> lezione2;
    // studenti
    
    Studente s1("paolo","rossi","12354"); // lez1
    Studente s2("mario","bianchi","12366"); // lez1
    Studente s3("antonio","verdi","12386"); // lez1 + lez2
    Studente s4("pinco","pallino","12554"); // lez2
    Studente s5("rosa","berardi","14386"); // lez1
    Studente s6("arianna","longo","12777"); // lez 2
    Studente s7("anna","marchesi","13732"); // lez 2
    Studente s8("giulio","bernardi","15690"); // lez1 + lez 2 
    
    // riempiamo la prima lista
    circLista<Studente>::posizione indiceElemento = lezione1.primoLista();
    lezione1.inslista(s1,indiceElemento=lezione1.succlista(indiceElemento));
    lezione1.inslista(s2,indiceElemento=lezione1.succlista(indiceElemento));
    lezione1.inslista(s3,indiceElemento=lezione1.succlista(indiceElemento));
    lezione1.inslista(s5,indiceElemento=lezione1.succlista(indiceElemento));
    lezione1.inslista(s8,indiceElemento=lezione1.succlista(indiceElemento));
    // riempiamo la seconda lista
    indiceElemento = lezione2.primoLista();
    lezione2.inslista(s3,indiceElemento=lezione2.succlista(indiceElemento));
    lezione2.inslista(s4,indiceElemento=lezione2.succlista(indiceElemento));
    lezione2.inslista(s6,indiceElemento=lezione2.succlista(indiceElemento));
    lezione2.inslista(s7,indiceElemento=lezione2.succlista(indiceElemento));
    lezione2.inslista(s8,indiceElemento=lezione2.succlista(indiceElemento));
    
    // stampo i dati acquisiti
    lezione1.stampaLista();
    lezione2.stampaLista();
    presente("13732", lezione1,lezione2);
    presente("13731", lezione1,lezione2);
    presente("12386", lezione1,lezione2);
    cout << "Dopo la prima lezione si sono annoiati in: " <<  contaAnnoiati(lezione1,lezione2) << endl;
    system("PAUSE");
    return EXIT_SUCCESS;
}
